#ifndef STANDARDCONSTANT_FX
#define STANDARDCONSTANT_FX

#include "stdafx.fx"


//====================================================================================================
// Define
//----------------------------------------------------------------------------------------------------

/// C[t[̐Fɂ邩ǂ
#define WIREFRAME_BLACK


//====================================================================================================
// Struct
//----------------------------------------------------------------------------------------------------

/// AvP[V炭钸_obt@ւ̏
struct SAppData
{
	float3	mPosition		: POSITION;		///< ʒuW
	float4	mUV				: TEXCOORD0;	///< eNX`W
	float	mInstanceIndex	: TEXCOORD1;	///< CX^XCfbNX
};

/// _obt@sNZVF[_֓nf[^
struct SVertexOutput
{
    float4	mPosition	: POSITION;		///< ʒuW
    float2	mUV			: TEXCOORD0;	///< eNX`W
    int		mIsVisible	: TEXCOORD1;	///< `tO
};


//====================================================================================================
// VertexShader
//----------------------------------------------------------------------------------------------------

/// C
SVertexOutput MainVS(SAppData sIn)
{
	// o̓f[^p
	SVertexOutput sOut = (SVertexOutput)0;


	// ʒuWZo
	float4 pos = float4(sIn.mPosition, 1);
	pos = mul(pos, gWorld);
	pos.xyz += gInstancePositions[sIn.mInstanceIndex].xyz;
	//pos.xyz += float4(0, 0, 10, 1).xyz;	//< TESTp
	pos = mul(pos, gView);
	pos = mul(pos, gProjection);
	pos = mul(pos, gViewport);
	
	sOut.mPosition = pos;


	// UVWݒ
	float4 uv4 = float4(sIn.mUV.xy, 1.0f, 1.0f);
	sOut.mUV = mul(uv4, gUVMatrix).xy;

	// `tO
	sOut.mIsVisible = 1;
	if (!gInstanceVisibles[sIn.mInstanceIndex])
	{
		sOut.mIsVisible = -1;
	}


	// o
	return sOut;
}


//====================================================================================================
// PixelShader
//----------------------------------------------------------------------------------------------------

/// C
float4 MainPS(SVertexOutput sIn) : COLOR
{
	// fBt[YJ[p
	float3 diffuseColor = tex2D(DiffuseSampler, sIn.mUV).rgb;

	// fBt[YeNX`TvO
	float3 result = diffuseColor * (0 + gAmbientColor);
	
	// `tOB0ł͂ȂA0łȂƔ\ɂȂȂB
	clip(sIn.mIsVisible);
	
    return float4(result, 1);
}

/// C[t[p
float4 WireframePS(SVertexOutput sIn) : COLOR
{
#ifdef WIREFRAME_BLACK
	// lFɂ
    return float4(0, 0, 0, 1);
#else
	// fBt[YJ[p
	float3 diffuseColor = tex2D(DiffuseSampler, sIn.mUV).rgb;
	// fBt[YeNX`TvO
	float3 result = diffuseColor * (0 + gAmbientColor);

	// یFɂȂȂ悤ɔ]
	result = float3(1, 1, 1) - result;

    return float4(result, 1);
#endif
}


//====================================================================================================
// Technique and Pass
//----------------------------------------------------------------------------------------------------

/// RX^g
technique Constant
{
	// \bh`pX
    pass Pass0
    {
        // _[Xe[gݒ
        AlphaBlendEnable = False;
        SrcBlend = SrcAlpha;
        DestBlend = InvSrcAlpha;
        Lighting = False;

#ifdef D3DX
	    CullMode = CCW;
#else
	    CullMode = CW;
#endif
        
        ZEnable = True;
        ZWriteEnable = True;
        
        FillMode = Solid;
        
        
        // eNX`Xe[WXe[gݒ
        TEXTURETRANSFORMFLAGS[0] = COUNT2;
        ColorOp[0] = MODULATE;
        ColorArg1[0] = TEXTURE;
        ColorArg2[0] = DIFFUSE;
        AlphaOp[0] = MODULATE;
        AlphaArg1[0] = TEXTURE;
        AlphaArg2[0] = DIFFUSE;
        
        
        // o[ebNXVF[_
        VertexShader = compile vs_2_0 MainVS();
        
        // sNZVF[_
        PixelShader  = compile ps_2_0 MainPS();
    }
}

/// C[t[
technique WireFrame
{
	// C[t[`pX
    pass Pass0
    {        
	    CullMode = NONE;
        FillMode = Wireframe;
        
        // o[ebNXVF[_
        VertexShader = compile vs_2_0 MainVS();
        
        // sNZVF[_
        PixelShader  = compile ps_2_0 WireframePS();
    }
}

/// RX^gƃC[t[
technique ConstantWireFrame
{
	// \bh`pX
    pass Pass0
    {
        // _[Xe[gݒ
        AlphaBlendEnable = True;
        SrcBlend = SrcAlpha;
        DestBlend = InvSrcAlpha;
        Lighting = False;

#ifdef D3DX
	    CullMode = CCW;
#else
	    CullMode = CW;
#endif
        
        ZEnable = True;
        ZWriteEnable = True;
        
        FillMode = Solid;
        
        
        // eNX`Xe[WXe[gݒ
        TEXTURETRANSFORMFLAGS[0] = COUNT2;
        ColorOp[0] = MODULATE;
        ColorArg1[0] = TEXTURE;
        ColorArg2[0] = DIFFUSE;
        AlphaOp[0] = MODULATE;
        AlphaArg1[0] = TEXTURE;
        AlphaArg2[0] = DIFFUSE;
        
        
        // o[ebNXVF[_
        VertexShader = compile vs_2_0 MainVS();
        
        // sNZVF[_
        PixelShader  = compile ps_2_0 MainPS();
    }
	
	// C[t[`pX
    pass Pass1
    {        
        FillMode = Wireframe;
        
        
        // o[ebNXVF[_
        VertexShader = compile vs_2_0 MainVS();
        
        // sNZVF[_
        PixelShader  = compile ps_2_0 WireframePS();
    }
}

#endif // STANDARDCONSTANT_FX