#ifndef MAINGAMEDATAMANAGER_H
#define MAINGAMEDATAMANAGER_H
//
#include "Camera3DOperation.h"
#include "DropItem.h"
#include "EnemyChipset.h"
#include "Character.h"
#include "FloorTrap.h"

#include "Blast/Graphic/DirectX9/XYZAxisDX9.h"
#include "Blast/Graphic/DirectX9/GridDX9.h"
#include "Blast/Graphic/DirectX9/CrosshairDX9.h"

#include "TerrainGrid.h"
#include "DropItemManager.h"
#include "UnitManager.h"
#include "TrapManager.h"
#include "NextMassManager.h"


///< MainGameł̏Ǘ
class MainGameDataManager
{
	//====================================================================================================
	// Operation
	//----------------------------------------------------------------------------------------------------

public:
	///< RXgN^
	MainGameDataManager();
	///< fXgN^
	~MainGameDataManager();


	//====================================================================================================
	// Property
	//----------------------------------------------------------------------------------------------------

	SP<Camera3DOperation>				GetCamera();			///< J擾
	SP<EnemyChipset>					GetEnemyChipset();		///< G̃`bvZbg擾
	std::list< SP<DropItem> >*			GetDropItems();			///< ĂACeQ
	SP<Character>						GetPlayer();			///< vC[LN^[擾
	std::list< SP<FloorTrap> >*			GetFloorTraps();		///< 㩌Q擾
#if _DEBUG
	SP<Blast::Graphic::XYZAxisDX9>		GetXYZAxis();			///< XYZ擾
	SP<Blast::Graphic::GridDX9>			GetGrid();				///< Obh擾
	SP<Blast::Graphic::CrosshairDX9>	GetCrossHair();			///< NXwA擾
#endif // _DEBUG
	SP<TerrainGrid>						GetTerrainGrid();		///< n`擾
	SP<DropItemManager>					GetDropItemManager();	///< ̊Ǘ擾
	SP<UnitManager>						GetUnitManager();		///< ̊Ǘ擾
	SP<TrapManager>						GetTrapManager();		///< 㩂̊Ǘ擾
	SP<NextMassManager>					GetNextMassManager();	///< lNXg}X̊Ǘ擾


	//====================================================================================================
	// Field
	//----------------------------------------------------------------------------------------------------

private:
	SP<Camera3DOperation>		mPCamera3D;			///< J
	SP<EnemyChipset>			mPEnemyChipset;		///< G̃`bvZbg
	std::list< SP<DropItem> >	mDropItems;			///< ĂACeQ
	SP<Character>				mPPlayer;			///< vC[LN^[
	std::list< SP<FloorTrap> >	mFloorTraps;		///< 㩌Q
#if _DEBUG
	SP<Blast::Graphic::XYZAxisDX9>		mPXYZAxis;		///< XYZ
	SP<Blast::Graphic::GridDX9>			mPGrid;			///< Obh
	SP<Blast::Graphic::CrosshairDX9>	mPCrosshair;	///< NXwABmFpȂ̂Ŋe탂fɗpӂ̂ł͂ȂA̕ϐg񂷁B
#endif // _DEBUG
	SP<TerrainGrid>			mPTerrainGrid;		///< n`
	SP<DropItemManager>		mPDropItemManager;	///< 
	SP<UnitManager>			mPUnitManager;		///< ̊Ǘ
	SP<TrapManager>			mPTrapManager;		///< 㩂̊Ǘ
	SP<NextMassManager>		mPNextMassManager;	///< lNXg}X̊Ǘ
};

#endif // MAINGAMEDATAMANAGER_H